package com.fr.plugin.loginAuth.dbAccessProvider;

import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-25
 **/
public class AuthUserDao extends BaseDAO<AuthUserEntity> {

    public AuthUserDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<AuthUserEntity> getEntityClass() {
        return AuthUserEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return AuthUserEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return AuthUserDao.class;
        }
    };

    public List<AuthUserEntity> getByUserName(String username ) throws Exception{
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.eq(AuthUserEntity.COLUMN_WORKCODE, username));
        return find(condition);

//        QueryCondition condition = QueryFactory.create()
//                .addRestriction(RestrictionFactory.eq(AuthUserEntity.COLUMN_WORKCODE, username));
//
//        return find(condition);
    }
//    public List<AuthUserEntity> likeByKey(String key )throws Exception{
//        QueryCondition condition = QueryFactory.create()
//                .addRestriction(RestrictionFactory.eq(AuthUserEntity.COLUMN_CD, key));
//        return find(condition);
//    }
//
//    public List<AuthUserEntity> like(String pid, String type)throws Exception{
//        QueryCondition condition = QueryFactory.create()
//                .addRestriction(RestrictionFactory.like(AuthUserEntity.COLUMN_CD, pid)).addRestriction(RestrictionFactory.like(AuthUserEntity.COLUMN_CD,type));
//        return find(condition);
//    }
//
    public void add(AuthUserEntity entity) throws Exception {
        getSession().persist(entity);
    }
//
//    public void update(AuthUserEntity entity) throws Exception {
//        getSession().merge(entity);
//    }
//
//    public AuthUserEntity getById(String id) throws Exception {
//        return getSession().getById(id, AuthUserEntity.class);
//    }
//
//    public void remove(String id) throws Exception {
//        getSession().remove(QueryFactory.create()
//                .addRestriction(RestrictionFactory.eq("id", id)),
//                this.getEntityClass());
//    }
}
