package com.fr.plugin.loginAuth.handler;

import com.fr.base.ServerConfig;
import com.fr.decision.config.AppearanceConfig;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.web.LoginComponent;
import com.fr.decision.webservice.utils.WebServiceUtils;
import com.fr.decision.webservice.v10.config.ConfigService;
import com.fr.decision.webservice.v10.login.LoginService;
import com.fr.general.CloudCenter;
import com.fr.general.CloudCenterConfig;
import com.fr.security.SecurityConfig;
import com.fr.security.encryption.SystemEncryptionManager;
import com.fr.security.encryption.transmission.impl.SM4TransmissionEncryption;
import com.fr.third.fasterxml.jackson.databind.ObjectMapper;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.Browser;
import com.fr.web.struct.AtomBuilder;
import com.fr.web.struct.PathGroup;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

public class ToDecisionLogin extends BaseHttpHandler {


    public ToDecisionLogin() {
    }

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/toDecisionLogin";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {

        //特定版本
        Map<String, Object> param = new HashMap();
        ObjectMapper mapper = new ObjectMapper();
        param.put("title", AppearanceConfig.getInstance().getPlatformTitle());
        param.put("loginConfig", mapper.writeValueAsString(ConfigService.getInstance().getLoginAppearanceConfig()));
        param.put("charset", ServerConfig.getInstance().getServerCharset());
        PathGroup group = AtomBuilder.create().buildAssembleFilePath(Browser.resolve(req), LoginComponent.KEY);
        param.put("styleTag", AtomBuilder.create().toHtmlTag(group.toStylePathGroup()));
        param.put("scriptTag", AtomBuilder.create().toHtmlTag(group.toScriptPathGroup()));
        Map<String, Object> system = new HashMap();
        system.put("frontSeed", SecurityConfig.getInstance().getFrontSeed());
        system.put("cloudEnabled", CloudCenterConfig.getInstance().isOnline());
        system.put("urlIP", CloudCenter.getInstance().acquireConf("decision.queryip", ""));
        if (AppearanceConfig.getInstance().isCopyrightInfoDisplay()) {
            system.putAll(LoginService.getInstance().getCopyrightInfo(req));
        }

        param.put("system", mapper.writeValueAsString(system));
        String a = WebServiceUtils.parseWebPageResourceSafe("/com/fr/plugin/loginAuth/js/login.html", param);
        WebUtils.printAsString(res, a);
//                HashMap var3 = new HashMap();
//        ObjectMapper var4 = new ObjectMapper();
//        var3.put("title", AppearanceConfig.getInstance().getPlatformTitle());
//        var3.put("loginConfig", var4.writeValueAsString(ConfigService.getInstance().getLoginAppearanceConfig()));
//        var3.put("charset", ServerConfig.getInstance().getServerCharset());
//        PathGroup var5 = AtomBuilder.create().buildAssembleFilePath(Browser.resolve(req), LoginComponent.KEY);
//        var3.put("styleTag", AtomBuilder.create().toHtmlTag(var5.toStylePathGroup()));
//        var3.put("scriptTag", AtomBuilder.create().toHtmlTag(var5.toScriptPathGroup()));
//        HashMap var6 = new HashMap();
//        var6.put("frontSeed", SecurityConfig.getInstance().getFrontSeed());
//        var6.put("transmissionEncryption", SystemEncryptionManager.getInstance().getTransmissionEncryption().getType());
//        var6.put("frontSM4Key", SM4TransmissionEncryption.getInstance().getTransmissionKey());
//        var6.put("cloudEnabled", CloudCenterConfig.getInstance().isOnline());
//        var6.put("urlIP", CloudCenter.getInstance().acquireConf("decision.queryip", ""));
//        if (AppearanceConfig.getInstance().isCopyrightInfoDisplay()) {
//            var6.putAll(LoginService.getInstance().getCopyrightInfo(req));
//        }
//
//        var3.put("system", var4.writeValueAsString(var6));
//
//        String a =WebServiceUtils.parseWebPageResourceSafe("/com/fr/web/controller/decision/entrance/resources/login.html", var3);
//        WebUtils.printAsString(res, a);
    }




}

